//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "ImageProcess.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#define min(a, b)  (((a) < (b)) ? (a) : (b))
#define max(a, b)  (((a) > (b)) ? (a) : (b))

TForm1 *Form1;

int p1[640][480];
int p2[640][480];
int p3[640][480];
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
 if (OpenPictureDialog1->Execute())
  Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
 if (Image1->Picture->Bitmap->Empty==true)
 ShowMessage("иJ!!");
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Byte *ptr;
 int r,g,b;
 int gray;
 int i,j;
 int threshold;
 Bmp->Assign(Image1->Picture->Bitmap);
 for(j=0;j<Bmp->Height;j++)
 {
  ptr = (Byte *)Bmp->ScanLine[j];
  for(i=0;i<Bmp->Width;i++)
  {
   b=ptr[i*3];
   g=ptr[i*3+1];
   r=ptr[i*3+2];
   gray=0.299*r +0.587*g+0.114*b;
   ptr[i*3]=(Byte)gray;
   ptr[i*3+1]=(Byte)gray;
   ptr[i*3+2]=(Byte)gray;
  }
 }
 Image2->Picture->Assign(Bmp);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
 if (Image1->Picture->Bitmap->Empty==true)
 ShowMessage("иJ!!");
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Byte *ptr;
 int r,g,b;
 int gray;
 int i,j;
 int threshold;
 threshold=ScrollBar1->Position;
 Edit1->Text=ScrollBar1->Position;
 Bmp->Assign(Image1->Picture->Bitmap);
 for(j=0;j<Bmp->Height;j++)
 {
  ptr = (Byte *)Bmp->ScanLine[j];
  for(i=0;i<Bmp->Width;i++)
  {
   b=ptr[i*3];
   g=ptr[i*3+1];
   r=ptr[i*3+2];
   gray=0.299*r +0.587*g+0.114*b;
   if(gray>threshold)
    gray=255;
   else
    gray=0;
   ptr[i*3]=(Byte)gray;
   ptr[i*3+1]=(Byte)gray;
   ptr[i*3+2]=(Byte)gray;
  }
 }
Image2->Picture->Assign(Bmp);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Byte *ptr;
 int r,g,b;
 int gray;
 int i,j;
 int threshold;
 threshold=ScrollBar1->Position;
 Edit1->Text=ScrollBar1->Position;
 Bmp->Assign(Image1->Picture->Bitmap);
 for(j=0;j<Bmp->Height;j++)
 {
  ptr = (Byte *)Bmp->ScanLine[j];
  for(i=0;i<Bmp->Width;i++)
  {
   b=ptr[i*3];
   g=ptr[i*3+1];
   r=ptr[i*3+2];
   gray=0.299*r +0.587*g+0.114*b;
   if(gray>threshold)
    gray=255;
   else
    gray=0;
   ptr[i*3]=(Byte)gray;
   ptr[i*3+1]=(Byte)gray;
   ptr[i*3+2]=(Byte)gray;
  }
 }
 Image2->Picture->Assign(Bmp);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
 if (Image2->Picture->Bitmap->Empty==true)
  ShowMessage("SiHsɪe!!");
 else
  if (SavePictureDialog1->Execute())
   Image2->Picture->SaveToFile(SavePictureDialog1->FileName);
}
//---------------------------------------------------------------------------
 int __fastcall TForm1::Filter(int i,int j)
{
 int LPF;
 int p[10];
 p[1]=p1[i-1][j-1];
 p[2]=p1[i][j-1];
 p[3]=p1[i+1][j-1];
 p[4]=p1[i-1][j];
 p[5]=p1[i][j];
 p[6]=p1[i+1][j];
 p[7]=p1[i-1][j+1];
 p[8]=p1[i][j+1];
 p[9]=p1[i+1][j+1];

 LPF=(p[1]+p[2]+p[3]+p[4]+p[5]+p[6]+p[7]+p[8]+p[9])/9;

 if (LPF<0)
 LPF=(-1)*LPF;
 return (LPF);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::ExpendFilter(int i,int j)
{
 int Expend;
 int p[10];
 p[1]=p1[i-1][j-1];
 p[2]=p1[i][j-1];
 p[3]=p1[i+1][j-1];
 p[4]=p1[i-1][j];
 p[5]=p1[i][j];
 p[6]=p1[i+1][j];
 p[7]=p1[i-1][j+1];
 p[8]=p1[i][j+1];
 p[9]=p1[i+1][j+1];
 Expend=(p[1]+p[2]+p[3]+p[4]+p[6]+p[7]+p[8]+p[9]);
 if (Expend<0)
  Expend=(-1)*Expend;
 return (Expend);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::ErosionFilter(int i,int j)
{
 int Erosion;
 int p[10];
 p[1]=p1[i-1][j-1];
 p[2]=p1[i][j-1];
 p[3]=p1[i+1][j-1];
 p[4]=p1[i-1][j];
 p[5]=p1[i][j];
 p[6]=p1[i+1][j];
 p[7]=p1[i-1][j+1];
 p[8]=p1[i][j+1];
 p[9]=p1[i+1][j+1];
 Erosion=(p[1]&p[2]&p[3]&p[4]&p[5]&p[6]&p[7]&p[8]&p[9]);
 if (Erosion<0)
  Erosion=(-1)*Erosion;
 return (Erosion);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
 if (Image1->Picture->Bitmap->Empty==true)
 ShowMessage("иJ!!");
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Byte *ptr;
 Bmp->Assign(Image1->Picture->Bitmap );

 for (int i=0;i<Bmp->Height;i++ )
   {
    ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
    {
     p1[j][i]=ptr[j*3];
    }
   }

 for (int i=0;i<Bmp->Height;i++ )
   {
    ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
    {
     ptr[j*3]=Filter(j,i);
     ptr[j*3+1]=Filter(j,i);
     ptr[j*3+2]=Filter(j,i);
    }
   }
 Image2->Picture->Assign(Bmp);
 delete Bmp;
}
//---------------------------------------------------------------------------
int __fastcall TForm1::Gx(int i,int j)
{
 int GX;
 int p[10];
 p[1]=p1[i-1][j-1];
 p[2]=p1[i][j-1];
 p[3]=p1[i+1][j-1];
 p[4]=p1[i-1][j];
 p[5]=p1[i][j];
 p[6]=p1[i+1][j];
 p[7]=p1[i-1][j+1];
 p[8]=p1[i][j+1];
 p[9]=p1[i+1][j+1];
 GX=((p[7]+p[8]+p[9])-(p[1]+p[2]+p[3]))/4;
 if (GX<0)
 GX=(-1)*GX;
 return (GX);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::Gy(int i,int j)
{
 int GY;
 int p[10];
 p[1]=p1[i-1][j-1];
 p[2]=p1[i][j-1];
 p[3]=p1[i+1][j-1];
 p[4]=p1[i-1][j];
 p[5]=p1[i][j];
 p[6]=p1[i+1][j];
 p[7]=p1[i-1][j+1];
 p[8]=p1[i][j+1];
 p[9]=p1[i+1][j+1];
 GY=((p[1]+p[4]+p[7])-(p[3]+p[6]+p[9]))/4;
 if (GY<0)
 GY=(-1)*GY;
 return (GY);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
 if (Image1->Picture->Bitmap->Empty==true)
 ShowMessage("иJ!!");
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Byte *ptr;
 Bmp->Assign(Image1->Picture->Bitmap );
 for (int i=0;i<Bmp->Height;i++ )
 {
  ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
  {
   p1[j][i]=ptr[j*3];
  }
 }
 for (int i=0;i<Bmp->Height;i++ )
 {
  ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
   {
      ptr[j*3]=Gx(j,i)+Gy(j,i);
    ptr[j*3+1]=Gx(j,i)+Gy(j,i);
    ptr[j*3+2]=Gx(j,i)+Gy(j,i);
   }
  }
  Image2->Picture->Assign(Bmp);
  delete Bmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
 Image2->AutoSize=true;
 int angle=StrToInt(Edit2->Text);
 Graphics::TBitmap *Bitmap1=new Graphics::TBitmap;
 Graphics::TBitmap *Bitmap2=new Graphics::TBitmap;
 Bitmap1->Assign(Image1->Picture->Bitmap);
 float radians=(2*3.1416*angle)/360;
 float cosine=(float)cos(radians);
 float sine=(float)sin(radians);
 float Point1x=(-Bitmap1->Height*sine);
 float Point1y=(Bitmap1->Height*cosine);
 float Point2x=(Bitmap1->Width*cosine-Bitmap1->Height*sine);
 float Point2y=(Bitmap1->Height*cosine+Bitmap1->Width*sine);
 float Point3x=(Bitmap1->Width*cosine);
 float Point3y=(Bitmap1->Width*sine);
 float minx=min(0,min(Point1x,min(Point2x,Point3x)));
 float miny=min(0,min(Point1y,min(Point2y,Point3y)));
 float maxx=max(Point1x,max(Point2x,Point3x));
 float maxy=max(Point1y,max(Point2y,Point3y));
 int Bitmap2Width=(int)ceil(maxx-minx);
 int Bitmap2Height=(int)ceil(maxy-miny);
 Bitmap2->Height=Bitmap2Height;
 Bitmap2->Width=Bitmap2Width;
 for(int x=0;x<Bitmap2Width;x++)
 {
  for(int y=0;y<Bitmap2Height;y++)
  {
   int Bitmap1x=(int)((x+minx)*cosine+(y+miny)*sine);
   int Bitmap1y=(int)((y+miny)*cosine-(x+minx)*sine);
   if(Bitmap1x>=0&&Bitmap1x<Bitmap1->Width&&Bitmap1y>=0&&Bitmap1y<Bitmap1->Height)
   {
    Bitmap2->Canvas->Pixels[x][y]=Bitmap1->Canvas->Pixels[Bitmap1x][Bitmap1y];
   }
  }
}
Image2->Picture->Bitmap=Bitmap2;
delete Bitmap2;
delete Bitmap1;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
 if (Image1->Picture->Bitmap->Empty==true)
 ShowMessage("иJ!!");
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Byte *ptr;
 Bmp->Assign(Image1->Picture->Bitmap );
 for (int i=0;i<Bmp->Height;i++ )
 {
  ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
  {
   p1[j][i]=ptr[j*3];
  }
 }
 for (int i=0;i<Bmp->Height;i++ )
 {
  ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
  {
   ptr[j*3]=Filter1(j,i);
   ptr[j*3+1]=Filter1(j,i);
   ptr[j*3+2]=Filter1(j,i);
  }
 }
 Image2->Picture->Assign(Bmp);
 delete Bmp;
}
//---------------------------------------------------------------------------
int __fastcall TForm1::Filter1(int i,int j)
{
 int MPF;
 int p[10],temp;
 p[1]=p1[i-1][j-1];
 p[2]=p1[i][j-1];
 p[3]=p1[i+1][j-1];
 p[4]=p1[i-1][j];
 p[5]=p1[i][j];
 p[6]=p1[i+1][j];
 p[7]=p1[i-1][j+1];
 p[8]=p1[i][j+1];
 p[9]=p1[i+1][j+1];

 for (int x=1;x<9 ;x++)
 {
  for (int y=x+1;y<10;y++)
  {
   if (p[x]<p[y])
   {
    temp=p[x];
    p[x]=p[y];
    p[y]=temp;
   }
  }
 }
 MPF=(p[5]);
 if (MPF<0)
 MPF=(-1)*MPF;
 return (MPF);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Byte *ptr;
 Bmp->LoadFromFile("test.bmp");
 Image1->Picture->Assign(Bmp);
 for (int i=0;i<Bmp->Height;i++ )
 {
  ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
  {
   p1[j][i]=ptr[j*3];
  }
 }
 for (int i=0;i<Bmp->Height;i++ )
 {
  ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
  {
   ptr[j*3]=ExpendFilter(j,i);
   ptr[j*3+1]=ExpendFilter(j,i);
   ptr[j*3+2]=ExpendFilter(j,i);
  }
 }
 Image2->Picture->Assign(Bmp);
 delete Bmp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Byte *ptr;
 Bmp->LoadFromFile("test.bmp");
 Image1->Picture->Assign(Bmp);
 for(int i=0;i<Bmp->Height;i++ )
 {
  ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
  {
   p1[j][i]=ptr[j*3];
  }
 }
 for (int i=0;i<Bmp->Height;i++ )
 {
  ptr=(Byte*)Bmp->ScanLine[i];
  for (int j=0;j<Bmp->Width; j++ )
  {
   ptr[j*3]=ErosionFilter(j,i);
   ptr[j*3+1]=ErosionFilter(j,i);
   ptr[j*3+2]=ErosionFilter(j,i);
  }
 }
 Image2->Picture->Assign(Bmp);
 delete Bmp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
 Image1->Picture->LoadFromFile("color.bmp");
 
 ShowMessage("ЦbϤWI@U~~");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 Image2->Transparent=true;
 Graphics::TBitmap *Bmp = new Graphics::TBitmap();
 Bmp->Assign(Image1->Picture->Bitmap);
 Bmp->Transparent = true;
 Bmp->TransparentColor = Bmp->Canvas->Pixels[X][Y];
 Image2->Picture->Assign(Bmp);
 delete Bmp;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::FormCreate(TObject *Sender)
{
 Form1->DoubleBuffered=true;        
}
//---------------------------------------------------------------------------



void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
 Image2->Transparent=false;        
}
//---------------------------------------------------------------------------

